import * as React from 'react';
import { ITranslations } from './types';
interface IProps {
    defaultLanguage?: string;
    languages: string[];
    translations: ITranslations;
    localizeUrls?: boolean;
}
interface IState {
    language: string;
}
declare class LocaleProvider extends React.Component<IProps, IState> {
    state: {
        language: string;
    };
    componentDidMount(): void;
    /**
     * * Resolve the initiale language setting from hard setting or from the browser setting
     */
    private resolveIntialLanguage;
    private getLanguageFromLocationState;
    private setLanguage;
    private getLanguageFromUrl;
    private insertLanguageToUrl;
    private updateUrl;
    private updateBrowserStorage;
    private handleError;
    /**
     * Check if searchedString and replaced string as the same
     * If the text is the same, then return true
     * @param searchedString
     * @param replacedString
     */
    private compareSearchedAndReplacedString;
    /**
     * * Perfroms variables search/replace of vars on the set translation
     * @param textToReplaceVars
     * @param searchValue
     * @param replaceValue
     * @param varKey
     */
    private replaceVars;
    /**
     * Process variables provided as props
     * @param translatedText
     */
    private processVars;
    private performTranslation;
    private performTranslationAndParse;
    /**
     * * Checks if the translated text is HTML
     * https://stackoverflow.com/questions/15458876/check-if-a-string-is-html-or-not/15458987
     * @param text
     */
    render(): JSX.Element | null;
}
export { LocaleProvider };
