var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as React from 'react';
import { Switch } from 'react-router-dom';
import { LocalizedRedirect } from './LocalizedRedirect';
import { LocalizedRoute } from './LocalizedRoute';
import { getLocalizedPath, getLocalizedRoute } from './localizer';
import { Translator } from './Translator';
/**
 * * Intepretes route config
 * @param props
 */
var LocalizedRoutes = function (props) {
    var _a = props.applySwitch, applySwitch = _a === void 0 ? false : _a, _b = props.routes, routes = _b === void 0 ? [] : _b, _c = props.localize, localizeRouteConfig = _c === void 0 ? true : _c;
    var getConfig = function (config) {
        return config.map(function (route, index) {
            var children = route.children, component = route.component, exact = route.exact, from = route.from, location = route.location, path = route.path, push = route.push, render = route.render, sensitive = route.sensitive, strict = route.strict, _a = route.localize, localize = _a === void 0 ? localizeRouteConfig === false ? false : true : _a, to = route.to, nestedRoutes = route.routes;
            var isRedirect = to ? true : false;
            var resolveRedirectFrom = function (language) {
                if (localize) {
                    return getLocalizedRoute(language, from);
                }
                if (localizeRouteConfig) {
                    return getLocalizedRoute(language, from);
                }
                return from;
            };
            var resolvePath = function () {
                // * Singular localize setting passed in config should take presedence
                if (localize) {
                    return getLocalizedPath(path);
                }
                // * localize config passed as Config prop takes 2nd stage
                if (localizeRouteConfig) {
                    return getLocalizedPath(path);
                }
                return path;
            };
            if (isRedirect) {
                return (React.createElement(React.Fragment, { key: index },
                    React.createElement(Translator, { render: function (language) { return (React.createElement(LocalizedRedirect, __assign({ from: resolveRedirectFrom(language), localize: localize === false ? false : localize || localizeRouteConfig }, { to: to, push: push, path: path, exact: exact, strict: strict }))); } })));
            }
            if (path || component || render) {
                return (React.createElement(LocalizedRoute, __assign({ key: index, path: resolvePath() }, { children: children, location: location, render: render, sensitive: sensitive, component: component, exact: exact }), nestedRoutes && getConfig(nestedRoutes)));
            }
            return null;
        });
    };
    var routeConfig = getConfig(routes);
    if (applySwitch) {
        return React.createElement(Switch, null, routeConfig);
    }
    return React.createElement(React.Fragment, null, routeConfig);
};
export { LocalizedRoutes };
