var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var getLocalizedUrl = function (language, url) {
    return "/" + (language + url);
};
var getLocalizedRoute = function (language, location) {
    var languagePrefix = language === null ? ':language' : language;
    if (typeof location === 'undefined') {
        return location;
    }
    if (typeof location === 'string') {
        return getLocalizedUrl(languagePrefix, location);
    }
    // * if the history push arg is an object, ie { pathname: sting, search: query, state: someState}
    return __assign(__assign({}, location), { pathname: getLocalizedUrl(languagePrefix, location.pathname || '') });
};
var concatenateLanguageParam = function (path) {
    return '/:language' + path;
};
var getLocalizedPath = function (path) {
    if (Array.isArray(path)) {
        return path.map(function (singlePath) {
            return concatenateLanguageParam(singlePath);
        });
    }
    if (typeof path === 'string') {
        return concatenateLanguageParam(path);
    }
    return undefined;
};
var getLanguageFromUrl = function (languages, url) {
    if (url === void 0) { url = window.location.pathname; }
    return languages.find(function (language) {
        var regExp = new RegExp("^/" + language, 'i');
        return url.search(regExp) >= 0;
    }) || null;
};
export { getLocalizedRoute, getLocalizedPath, getLanguageFromUrl };
